Kea: isc::yang::TranslatorHosts Class Reference

| Kea 2.2.0

Public Member Functions | Protected Member Functions | List of all members
isc::yang::TranslatorHosts Class Reference

A translator class for converting host reservations list between YANG and JSON. More...

`#include <translator_host.h>`

Inheritance diagram for isc::yang::TranslatorHosts:
[legend]

## Public Member Functions
| TranslatorHosts (sysrepo::S_Session session, const std::string &model)
| Constructor. More...
virtual | ~TranslatorHosts ()
| Destructor. More...
isc::data::ElementPtr | getHosts (const std::string &xpath)
| Get and translate host reservations from YANG to JSON. More...
void | setHosts (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set (address) host reservations from JSON to YANG. More...
Public Member Functions inherited from isc::yang::TranslatorHost
| TranslatorHost (sysrepo::S_Session session, const std::string &model)
| Constructor. More...
virtual | ~TranslatorHost ()
| Destructor. More...
isc::data::ElementPtr | getHost (const std::string &xpath)
| Get and translate a host reservation from YANG to JSON. More...
void | setHost (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set host reservation from JSON to YANG. More...
Public Member Functions inherited from isc::yang::TranslatorOptionDataList
| TranslatorOptionDataList (sysrepo::S_Session session, const std::string &model)
| Constructor. More...
virtual | ~TranslatorOptionDataList ()
| Destructor. More...
isc::data::ConstElementPtr | getOptionDataList (const std::string &xpath)
| Get and translate option data list from YANG to JSON. More...
void | setOptionDataList (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set option data list from JSON to YANG. More...
Public Member Functions inherited from isc::yang::TranslatorOptionData
| TranslatorOptionData (sysrepo::S_Session session, const std::string &model)
| Constructor. More...
virtual | ~TranslatorOptionData ()
| Destructor. More...
isc::data::ElementPtr | getOptionData (const std::string &xpath)
| Get and translate an option data from YANG to JSON. More...
void | setOptionData (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set option data from JSON to YANG. More...
Public Member Functions inherited from isc::yang::TranslatorBasic
| TranslatorBasic (sysrepo::S_Session session, const std::string &model)
| Constructor. More...
virtual | ~TranslatorBasic ()
| Destructor. More...
void | checkAndGetLeaf (isc::data::ElementPtr &storage, const std::string &xpath, const std::string &name)
| Retrieves an item and stores it in the specified storage. More...
void | checkAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, sr_type_t const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath. More...
void | delItem (const std::string &xpath)
| Delete basic value from YANG. More...
template<typename functor_t >
void | forAll (std::string const &xpath, functor_t f)
| Run a function for a node and all its children. More...
isc::data::ElementPtr | getItem (const std::string &xpath)
| Get and translate basic value from YANG to JSON. More...
isc::data::ElementPtr | getItems (const std::string &xpath)
| Get and translate a list of basic values from YANG to JSON. More...
template<typename T >
isc::data::ElementPtr | getList (std::string const &xpath, T &t, isc::data::ElementPtr(T::*f)(std::string const &xpath))
| Retrieve a list as ElementPtr from sysrepo from a certain xpath. More...
sysrepo::S_Vals | getValuesFromItems (std::string const &xpath)
| Get the values of all siblings at a certain xpath. More...
void | setItem (const std::string &xpath, isc::data::ConstElementPtr elem, sr_type_t type)
| Translate and set basic value from JSON to YANG. More...

## Protected Member Functions
void | setHostsKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setHosts for kea-dhcp[46]. More...
Protected Member Functions inherited from isc::yang::TranslatorHost
isc::data::ElementPtr | getHostKea (const std::string &xpath)
| getHost for kea-dhcp[46]-server models. More...
void | setHostKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setHost for kea-dhcp[46]-server models. More...
Protected Member Functions inherited from isc::yang::TranslatorOptionDataList
isc::data::ConstElementPtr | getOptionDataListKea (const std::string &xpath)
| getOptionDataList for kea-dhcp[46]. More...
void | setOptionDataListKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setOptionDataList for kea-dhcp[46]. More...
Protected Member Functions inherited from isc::yang::TranslatorOptionData
isc::data::ElementPtr | getOptionDataKea (const std::string &xpath)
| getOptionData JSON for kea-dhcp[46]. More...
void | setOptionDataKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setOptionData for kea-dhcp[46]. More...

## Additional Inherited Members
Static Public Member Functions inherited from isc::yang::TranslatorBasic
static sysrepo::S_Val | value (isc::data::ConstElementPtr elem, sr_type_t type)
| Translate basic value from JSON to YANG. More...
static isc::data::ElementPtr | value (sysrepo::S_Val s_val)
| Translate basic value from YANG to JSON. More...
Protected Attributes inherited from isc::yang::TranslatorBasic
std::string | model_
| The model. More...
sysrepo::S_Session | session_
| The sysrepo session. More...

## Detailed Description

A translator class for converting host reservations list between YANG and JSON.

Currently supports the following models:

- kea-dhcp4-server
- kea-dhcp6-server

The ietf-dhcpv6-server model is not yet supported.

Definition at line 161 of file translator_host.h.

## Constructor & Destructor Documentation

## ◆ TranslatorHosts()

isc::yang::TranslatorHosts::TranslatorHosts | ( | sysrepo::S_Session | session,
|  | const std::string & | model
| ) |  |

Constructor.

Parameters

  session | Sysrepo session.
  model | Model name.

Definition at line 182 of file translator_host.cc.

## ◆ ~TranslatorHosts()

isc::yang::TranslatorHosts::~TranslatorHosts | ( |  | ) |
| virtual

Destructor.

Definition at line 189 of file translator_host.cc.

## Member Function Documentation

## ◆ getHosts()

ElementPtr isc::yang::TranslatorHosts::getHosts | ( | const std::string & | xpath | ) |

Get and translate host reservations from YANG to JSON.

Parameters

  xpath | The xpath of the host reservation list.

Exceptions

  SysrepoError | when sysrepo raises an error.

Definition at line 193 of file translator_host.cc.

References isc::yang::TranslatorHost::getHost().

Referenced by isc::yang::TranslatorConfig::getServerKeaDhcpCommon().

Here is the call graph for this function:

## ◆ setHosts()

void isc::yang::TranslatorHosts::setHosts | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem
| ) |  |

Translate and set (address) host reservations from JSON to YANG.

Parameters

  xpath | The xpath of the host reservation list.
  elem | The JSON element.

Definition at line 199 of file translator_host.cc.

References isc_throw, isc::yang::TranslatorBasic::model_, setHostsKea(), and isc::Exception::what().

Referenced by isc::yang::TranslatorConfig::setServerKeaDhcpCommon().

Here is the call graph for this function:

## ◆ setHostsKea()

void isc::yang::TranslatorHosts::setHostsKea | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem
| ) |  |
| protected

setHosts for kea-dhcp[46].

Parameters

  xpath | The xpath of the host reservation list.
  elem | The JSON element.

Exceptions

  BadValue | on host reservation without known identifier type.

Definition at line 216 of file translator_host.cc.

References isc_throw, isc::yang::TranslatorBasic::model_, and isc::yang::TranslatorHost::setHost().

Referenced by setHosts().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- translator_host.h
- translator_host.cc